% Num. Math. - FS 2014 - Serie 8 Aufgabe 3 - solve Ax+b=0 with CG

for k=[40 100]
    A=model(k);
    b=-rhs(k);
    TOL=1e-7;
    MAXIT=1000;
    x0=zeros(size(b));
    %repeat N times to get a better timing
    N=10;
    time1=zeros(N,1);
    time2=zeros(N,1);
    time3=zeros(N,1);
    for n=1:N
        tic;
        [x,iter1]= cg(A,b,x0,MAXIT,TOL);
        time1(n)=toc;
        
        tic;
        [x,flag,relres,iter2]= pcg(A,-b,TOL,MAXIT);
        time2(n)=toc;
        
        %H=cholinc(A,1e-3)';
        H=ichol(A,struct('type','ict','droptol',1e-3));
        tic;
        [x,flag,relres,iter3]= pcg(A,-b,TOL,MAXIT,H,H');
        time3(n)=toc;
    end
    k
    [iter1 iter2 iter3]
    [mean(time1) mean(time2) mean(time3)]
    condest(A)
end
