function[x,k]=cg(A,b,x0,maxit,tol)
% CG zum Loesen der Gleichung Ax+b=0
% Algorithmus gemaess Skript
x=x0;
r0=A*x+b;
r=r0;
p=-r;
for k=1:maxit
    rTr1=r'*r;
    if k>=2
        ek = rTr1/rTr0;
        p=-r+ek*p;
    end
    Ap=A*p;
    rho=rTr1/(p'*Ap);
    x=x+rho*p;
    r=r+rho*Ap;
    rTr0=rTr1;
    if norm(r)<=tol*norm(r0)
        return
    end
end

if k==maxit
    error(['keine Konvergenz nach ',int2str(k),' Schritten'])
end
